//
//  ViewController.swift
//  Sample
//
//  Created by Asterisk on 2015/12/15.
//  Copyright © 2015年 Asterisk. All rights reserved.
//

import UIKit

class ViewController: UIViewController,RcpBarcodeDelegate {

    var reader: RcpBarcodeApi!
    @IBOutlet weak var myTextView: UITextView!
    @IBOutlet weak var statusLabel: UILabel!
    @IBOutlet weak var batteryLabel: UILabel!

    override func viewDidLoad() {
        super.viewDidLoad()
        self.reader = RcpBarcodeApi()
        self.reader.delegate = self
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func addText(text: String!){
        DispatchQueue.main.async() { () -> Void in
            self.myTextView.text = self.myTextView.text + text + ("\n")
        }
    }
    
    // MARK:IBAction Method
    @IBAction func tapToRead(_ sender: AnyObject) {
        self.reader.startReadBarcodes(0x00, mtime: 0x00, repeatCycle: 0x00)
    }
    
    @IBAction func tapToStop(_ sender: AnyObject) {
        self.reader.stopReadBarcodes()
    }

    @IBAction func tapToClear(_ sender: AnyObject) {
        DispatchQueue.main.async() { () -> Void in
            self.myTextView.text = ""
        }
    }

    // MARK:RcpBarcodeDelegate Method
    func pluggedBarcode(_ plug: Bool) {
        DispatchQueue.main.async() { () -> Void in
            if(plug){
                    self.reader.open()
                    self.reader.setReaderPower(true)
                    self.statusLabel.text = "Plugged"
            }else{
                    self.reader.setReaderPower(false)
                    self.reader.close()
                    self.statusLabel.text = "UnPlugged"
            }
        }

    }
    
    func barcodeReceived(_ barcode: Data?) {
        DispatchQueue.main.async() { () -> Void in
            guard let barcodeData:Data = barcode else{
                return
            }
            self.myTextView.text = self.myTextView.text + String(data: barcodeData, encoding: String.Encoding.shiftJIS)! + ("\n")
        }
    }
    func batteryChargeReceived(_ battery: Int32) {
        DispatchQueue.main.async() { () -> Void in
            self.batteryLabel.text = battery.description
        }
    }
    
}

